Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# EggNode Class Reference

A base class for things that may be directly added into the egg hierarchy. More...

Inheritance diagram for EggNode:

List of all members.

## Public Member Functions
| applyTexmats ()
| Applies the texture matrices to the UV's of the vertices that reference them, and then removes the texture matrices from the textures themselves.
EggRenderMode | determineAlphaMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has an alpha_mode other than AM_unspecified.
EggRenderMode | determineBin ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a bin specified.
bool | determineDecal ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.
EggRenderMode | determineDepthOffset ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_offset specified.
EggRenderMode | determineDepthTestMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_test_mode other than DTM_unspecified.
EggRenderMode | determineDepthWriteMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_write_mode other than DWM_unspecified.
EggRenderMode | determineDrawOrder ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a draw_order specified.
bool | determineIndexed ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.
EggRenderMode | determineVisibilityMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a visibility_mode other than VM_unspecified.
| flattenTransforms ()
| Removes any transform and instance records from this node in the scene graph and below.
int | getDepth ()
| Returns the number of nodes above this node in the egg hierarchy.
Mat4D const | getNodeFrame ()
| Returns the coordinate frame of the node itself.
Mat4D const | getNodeFrameInv ()
| Returns the inverse of the matrix returned by get_node_frame().
Mat4D const | getNodeFrameInvPtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame_inv() matrix.
Mat4D const | getNodeFramePtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame() matrix.
Mat4D const | getNodeToVertex ()
| Returns the transformation matrix suitable for converting vertices in the coordinate space of the node to the appropriate coordinate space for storing in the egg file.
Mat4D const | getNodeToVertexPtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_to_vertex() matrix.
EggGroupNode | getParent ()
Mat4D const | getVertexFrame ()
| Returns the coordinate frame of the vertices referenced by primitives at or under this node.
Mat4D const | getVertexFrameInv ()
| Returns the inverse of the matrix returned by get_vertex_frame().
Mat4D const | getVertexFrameInvPtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame_inv() matrix.
Mat4D const | getVertexFramePtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame() matrix.
Mat4D const | getVertexToNode ()
| Returns the transformation matrix suitable for converting the vertices as read from the egg file into the coordinate space of the node.
Mat4D const | getVertexToNodePtr ()
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_to_node() matrix.
bool | isAnimMatrix ()
| Returns true if this node represents a table of animation transformation data, false otherwise.
bool | isJoint ()
| Returns true if this particular node represents a <Joint> entry or not.
bool | isLocalCoord ()
| Returns true if this node's vertices are not in the global coordinate space.
bool | isUnderInstance ()
| Returns true if there is an <Instance> node somewhere in the egg tree at or above this node, false otherwise.
bool | isUnderTransform ()
| Returns true if there is a <Transform> entry somewhere in the egg tree at or above this node, false otherwise.
EggNode | operator= (EggNode const copy)
bool | parseEgg (string egg_syntax)
| Parses the egg syntax given in the indicate string as if it had been read from the egg file within this object's definition.
int | renameNode (vectorbasic_stringchar strip_prefix)
| Rename by stripping out the prefix.
| testUnderIntegrity ()
| transform (Mat4D const mat)
| Applies the indicated transformation to the node and all of its descendants.
| transformVerticesOnly (Mat4D const mat)
| Applies the indicated transformation only to vertices that appear in global space within vertex pools at this node and below.
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A base class for things that may be directly added into the egg hierarchy.

This includes groups, joints, polygons, vertex pools, etc., but does not include things like vertices.

## Member Function Documentation

applyTexmats | ( |  | ) |

Applies the texture matrices to the UV's of the vertices that reference them, and then removes the texture matrices from the textures themselves.

EggRenderMode determineAlphaMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has an alpha_mode other than AM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

EggRenderMode determineBin | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a bin specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

bool determineDecal | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.

Returns the value of the decal flag if it is found, or false if it is not.

In other words, returns true if the "decal" flag is in effect for the indicated node, false otherwise.

Reimplemented in EggGroup.

EggRenderMode determineDepthOffset | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_offset specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

EggRenderMode determineDepthTestMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_test_mode other than DTM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

EggRenderMode determineDepthWriteMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_write_mode other than DWM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

EggRenderMode determineDrawOrder | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a draw_order specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

bool determineIndexed | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.

Returns the value of the indexed scalar if it is found, or false if it is not.

In other words, returns true if the "indexed" flag is in effect for the indicated node, false otherwise.

Reimplemented in EggGroup.

EggRenderMode determineVisibilityMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a visibility_mode other than VM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented in EggGroup, and EggPrimitive.

flattenTransforms | ( |  | ) |

Removes any transform and instance records from this node in the scene graph and below.

If an instance node is encountered, removes the instance and applies the transform to its vertices, duplicating vertices if necessary.

Since this function may result in duplicated vertices, it may be a good idea to call remove_unused_vertices() after calling this.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from EggNamedObject.

Reimplemented in EggAnimData, EggAnimPreload, EggVertexPool, EggGroupNode, EggGroup, EggBin, EggComment, EggFilenameNode, EggTexture, EggMaterial, EggPrimitive, EggCompositePrimitive, EggData, EggCoordinateSystem, EggCurve, EggExternalReference, EggLine, EggPolygon, EggNurbsCurve, EggSurface, EggNurbsSurface, EggPoint, EggSAnimData, EggTable, EggTriangleFan, EggTriangleStrip, EggXfmSAnim, and EggXfmAnimData.

int getDepth | ( |  | ) |

Returns the number of nodes above this node in the egg hierarchy.

Mat4D const getNodeFrame | ( |  | ) |

Returns the coordinate frame of the node itself.

This is simply the net product of all transformations up to the root.

Mat4D const getNodeFrameInv | ( |  | ) |

Returns the inverse of the matrix returned by get_node_frame().

See get_node_frame().

Mat4D const getNodeFrameInvPtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame_inv() matrix.

Mat4D const getNodeFramePtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame() matrix.

Mat4D const getNodeToVertex | ( |  | ) |

Returns the transformation matrix suitable for converting vertices in the coordinate space of the node to the appropriate coordinate space for storing in the egg file.

This is the same thing as:

get_node_frame() * get_vertex_frame_inv()

Mat4D const getNodeToVertexPtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_to_vertex() matrix.

EggGroupNode getParent | ( |  | ) |

Mat4D const getVertexFrame | ( |  | ) |

Returns the coordinate frame of the vertices referenced by primitives at or under this node.

This is not the same as get_node_frame().

Generally, vertices in an egg file are stored in the global coordinate space, regardless of the transforms defined at each node. Thus, get_vertex_frame() will usually return the identity transform (global coordinate space). However, primitives under an <Instance> entry reference their vertices in the coordinate system under effect at the time of the <Instance>. Thus, nodes under an <Instance> entry may return this non-identity matrix.

Specifically, this may return a non-identity matrix only if is_local_coord() is true.

Mat4D const getVertexFrameInv | ( |  | ) |

Returns the inverse of the matrix returned by get_vertex_frame().

See get_vertex_frame().

Mat4D const getVertexFrameInvPtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame_inv() matrix.

Mat4D const getVertexFramePtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame() matrix.

Mat4D const getVertexToNode | ( |  | ) |

Returns the transformation matrix suitable for converting the vertices as read from the egg file into the coordinate space of the node.

This is the same thing as:

get_vertex_frame() * get_node_frame_inv()

Mat4D const getVertexToNodePtr | ( |  | ) |

Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_to_node() matrix.

bool isAnimMatrix | ( |  | ) |

Returns true if this node represents a table of animation transformation data, false otherwise.

bool isJoint | ( |  | ) |

Returns true if this particular node represents a <Joint> entry or not.

This is a handy thing to know since Joints are sorted to the end of their sibling list when writing an egg file. See EggGroupNode.write().

Reimplemented in EggGroup.

bool isLocalCoord | ( |  | ) |

Returns true if this node's vertices are not in the global coordinate space.

This will be the case if there was an <Instance> node under a transform at or above this node.

bool isUnderInstance | ( |  | ) |

Returns true if there is an <Instance> node somewhere in the egg tree at or above this node, false otherwise.

bool isUnderTransform | ( |  | ) |

Returns true if there is a <Transform> entry somewhere in the egg tree at or above this node, false otherwise.

EggNode operator= | ( | EggNode const | copy | ) |

bool parseEgg | ( | string | egg_syntax | ) |

Parses the egg syntax given in the indicate string as if it had been read from the egg file within this object's definition.

Updates the object accordingly. Returns true if successful, false if there was some parse error or if the object does not support this functionality.

int renameNode | ( | vectorbasic_stringchar | strip_prefix | ) |

Rename by stripping out the prefix.

testUnderIntegrity | ( |  | ) |

transform | ( | Mat4D const | mat | ) |

Applies the indicated transformation to the node and all of its descendants.

Reimplemented in EggVertexPool.

transformVerticesOnly | ( | Mat4D const | mat | ) |

Applies the indicated transformation only to vertices that appear in global space within vertex pools at this node and below.

Joints and other transforms are not affected, nor are local vertices.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Reimplemented in EggGroup, EggTexture, and EggPrimitive.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties